﻿// ================================================================
// Class Name:			ExtendedArray
// Extends:				Array
// Description:			배열과 동일하게 사용가능
// ----------------------------------------------------------------
// Author:				Zooil Yang
// Last modified:			2005/02/02
// Version:				1.0
// ================================================================


class ExtendedArray extends Array{
	
	private var _isSuffled:Boolean = false;
	
	//--------------- constructor  -----------------
	function ExtendedArray(){
		addItems(arguments);
	}	

	private function addItems(_array:Array):Void{
		for(var i=0;i<_array.length;i++){
			push(_array[i]);
		}
	}
	
	public function copy(_array:Array):Void{
		addItems(_array);
	}
	
	public function sum():Number{
		var total = 0;
		for(var i=0;i<length;i++){
			if(typeof this[i] == "number"){
				total += this[i];
			}else{
				trace("Element "+i +" : " + this[i] +" is not a Number type >> skipped");
			}
		}
		return total;
	}
	
	public function deleteAll():Void{
		super();
	}
	
	public function getRandomItem():Object{		
		if(_isSuffled == false) shuffle();
		var randIndex = random(length);
		var randomItem = splice(randIndex,1)[0];
		return randomItem;
	}

	public function getRandItem():Object{		
		if(_isSuffled == false) shuffle();
		return this[random(length)];
	}
	
	public function shuffle():Array{
		_isSuffled = true;
		var _array = shuffleArray(this);
		deleteAll();
		addItems(_array);
		return this;
	}
	
	static function shuffleArray(input_array:Array):Array{
	   	var copy_array =  input_array.concat();
		var shuffled_array = [];
		var randIndex;
		while(copy_array.length){
			randIndex = random(copy_array.length);
			shuffled_array.push(copy_array.splice(randIndex,1)[0]); 	
		}
	
		return shuffled_array;
	}
}